<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>AdminLTE 3 | Blank Page</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="index3.html" class="nav-link">Home</a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="index3.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Admin</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Anh Luong</a>
                    </div>
                </div>

                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    School Management
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="gradesManagement.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Grade Management</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="studentsManagement.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Student Management</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="subjectsManagement.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Subject Management</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1>Quản lý bảng điểm</h1>
                        </div>
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Quản lý bảng điểm</li>
                            </ol>
                        </div>
                    </div>
                </div><!-- /.container-fluid -->
            </section>

            <!-- Main content -->
            <section class="content">
                <!-- vùng header -->
                <div class="container">
                    <div class="text-center mt-3">
                        <h3>Bảng điểm</h3>
                    </div>
                    <div class="jumbotron container">
                        <div class="row form-group">
                            <div class="col-md-5 row">
                                <div class="col-md-6 text-center">
                                    <label class="form-group mx-2">Sinh viên</label>
                                </div>
                                <div class="col-md-6">
                                    <select id="select-student" class="form-control select2">
                                        <option value="all">Chọn sinh viên</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-5 row">
                                <div class="col-md-6 text-center">
                                    <label class="form-group mx-2">Môn học</label>
                                </div>
                                <div class="col-md-6">
                                    <select id="select-subject" class="form-control select2">
                                        <option value="all">Chọn môn học</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-2">
                                <div class="col-md-12 text-right">
                                    <button class="btn btn-success" id="btn-filter">Lọc</button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <button class="btn btn-success" id="btn-add-new"><i class="fa fa-plus"></i>&nbsp;Thêm
                            mới</button>
                    </div>
                </div>
                <!-- user data table -->
                <div class="container">
                    <table id="data-table" class="table table-bordered table-striped table-hover">
                        <thead>
                            <tr>
                                <th>STT</th>
                                <th>Sinh viên</th>
                                <th>Môn học</th>
                                <th>Điểm</th>
                                <th>Ngày thi</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                    </table>
                </div>
                <!-- vùng modal -->
                <!-- Modal Add new data -->
                <div class="modal fade" id="modal-add-data" tabindex="-1">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h4 class="modal-title">Thêm mới bảng điểm</h4>
                                <button type="button" class="close" data-dismiss="modal">&times;</button>
                            </div>
                            <div class="modal-body">
                                <form>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Tên sinh viên</label>
                                        <div class="col-sm-8">
                                            <select id="select-create-student" class="form-control select2">
                                                <option value="0">Tên sinh viên</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Môn học</label>
                                        <div class="col-sm-8">
                                            <select id="select-create-subject" class="form-control select2">
                                                <option value="0">Môn học</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Điểm</label>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-create-grade" placeholder="Điểm"
                                                class="form-control">
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Ngày thi</label>
                                        <div class="col-sm-8">
                                            <div class="input-group">
                                                <div class="input-group-prepend">
                                                    <span class="input-group-text"><i
                                                            class="far fa-calendar-alt"></i></span>
                                                </div>
                                                <input id="inp-create-examdate" type="text" class="form-control"
                                                    data-inputmask-alias="datetime"
                                                    data-inputmask-inputformat="dd/mm/yyyy" data-mask>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button id="btn-create-data" class="btn btn-primary">Thêm</button>
                                <button id="btn-create-cancel" class="btn btn-secondary"
                                    data-dismiss="modal">Hủy</button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Modal Update data -->
                <div class="modal fade" id="modal-update-data" tabindex="-1">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h4 class="modal-title">Cập nhật sinh viên</h4>
                                <button type="button" class="close" data-dismiss="modal">&times;</button>
                            </div>
                            <div class="modal-body">
                                <form>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Tên sinh viên</label>
                                        <div class="col-sm-8">
                                            <select id="select-update-student" class="form-control select2">
                                                <option value="0">Tên sinh viên</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Môn học</label>
                                        <div class="col-sm-8">
                                            <select id="select-update-subject" class="form-control select2">
                                                <option value="0">Môn học</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Điểm</label>
                                        <div class="col-sm-8">
                                            <input type="text" id="inp-update-grade" placeholder="Điểm"
                                                class="form-control">
                                        </div>
                                    </div>
                                    <div class="row form-group">
                                        <label class="col-form-label col-sm-4">Ngày thi</label>
                                        <div class="col-sm-8">
                                            <div class="input-group">
                                                <div class="input-group-prepend">
                                                    <span class="input-group-text"><i
                                                            class="far fa-calendar-alt"></i></span>
                                                </div>
                                                <input id="inp-update-examdate" type="text" class="form-control"
                                                    data-inputmask-alias="datetime"
                                                    data-inputmask-inputformat="dd/mm/yyyy" data-mask>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button id="btn-update-data" class="btn btn-primary">Cập nhật</button>
                                <button id="btn-update-cancel" class="btn btn-secondary"
                                    data-dismiss="modal">Hủy</button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Delete data modal -->
                <div>
                    <div class="modal fade" tabindex="-1" id="modal-delete-data">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="h5-modal-title">Xác nhận xóa bảng điểm</h5>
                                    <button class="close" data-dismiss="modal">&times;</button>
                                </div>
                                <div class="modal-body">
                                    <label>Bạn có chắc muốn xóa bảng điểm này không?</label>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-danger" id="btn-confirm-delete-data">Xác nhận</button>
                                    <button class="btn btn-secondary" data-dismiss="modal">Hủy</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
            <!-- /.content -->
        </div>
        <!-- /.content-wrapper -->

        <footer class="main-footer">
            <div class="float-right d-none d-sm-block">
                <b>Version</b> 3.2.0
            </div>
            <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights
            reserved.
        </footer>

        <!-- Control Sidebar -->
        <aside class="control-sidebar control-sidebar-dark">
            <!-- Control sidebar content goes here -->
        </aside>
        <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- Data Table-->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- Select2 -->
    <script src="plugins/select2/js/select2.full.min.js"></script>
    <!-- InputMask -->
    <script src="plugins/moment/moment.min.js"></script>
    <script src="plugins/inputmask/jquery.inputmask.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <script>
        $(document).ready(function () {
            "use strict";
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1";
            var gSubjectObj = [];
            var gStudentObj = [];
            var gData = []; //khai báo biến array để chứa data
            // biến toàn cục để lưu trữ student id đang dc update or delete. Mặc định = 0
            var gId = 0;
            //biến mảng hằng số chứa ds tên các thuộc tính
            var gDATA_COLS = ["stt", "studentId", "subjectId", "grade", "examDate", "action"];
            //biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
            var gSTT_COL = 0;
            var gFULLNAME_COL = 1;
            var gSUBJECT_COL = 2;
            var gGRADE_COL = 3;
            var gEXAM_DATE_COL = 4;
            var gACTION_COL = 5;
            //khai báo DataTable & mapping columns
            var gDataTable = $("#data-table").DataTable({
                columns: [
                    { data: gDATA_COLS[gSTT_COL] },
                    { data: gDATA_COLS[gFULLNAME_COL] },
                    { data: gDATA_COLS[gSUBJECT_COL] },
                    { data: gDATA_COLS[gGRADE_COL] },
                    { data: gDATA_COLS[gEXAM_DATE_COL] },
                    { data: gDATA_COLS[gACTION_COL] }
                ],
                columnDefs: [
                    {
                        targets: gSTT_COL,
                        render: renderStt
                    },
                    {
                        targets: gFULLNAME_COL,
                        render: renderStudentIdToStudentName
                    },
                    {
                        targets: gSUBJECT_COL,
                        render: renderSubjectIdToSubjectName
                    },
                    {
                        targets: gACTION_COL,
                        defaultContent: `
                <img class="edit-data" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                <img class="delete-data" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
                    }
                ]
            });
            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            //gán sự kiện cho nút Lọc
            $("#btn-filter").on("click", function () {
                onBtnFilterClick();
            });
            //2 - C: gán sự kiện Create-thêm mới data
            $("#btn-add-new").on("click", function () {
                onBtnAddNewClick();
            });
            //gán sự kiện cho nút Thêm(trên modal)
            $("#btn-create-data").on("click", function () {
                onBtnCreateDataClick();
            });
            //3 - U: gán sự kiện update-sửa 1 data
            $("#data-table").on("click", ".edit-data", function () {
                onBtnEditDataClick(this);
            });
            //gán sự kiện cho nút Cập nhật(trên modal)
            $("#btn-update-data").on("click", function () {
                onBtnUpdateDataClick();
            });
            //4 - D: gán sự kiện delete-xóa 1 data
            $("#data-table").on("click", ".delete-data", function () {
                onBtnDeleteDataClick(this);
            });
            //gán sự kiện cho nút Xóa(trên modal)
            $("#btn-confirm-delete-data").on("click", function () {
                onBtnDeleteDataConfirmClick();
            });
            //Datemask dd/mm/yyyy
            $('#inp-create-examdate').inputmask('dd/mm/yyyy', { 'placeholder': 'dd/mm/yyyy' });
            $('#inp-update-examdate').inputmask('dd/mm/yyyy', { 'placeholder': 'dd/mm/yyyy' });
            //Initialize Select2 Elements
            $('.select2').select2()

            //Initialize Select2 Elements
            $('.select2').select2({
                theme: 'bootstrap4'
            })
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                //1 - R: read/load data to table
                getDataToLoadToTable();
                getStudentList();
                getSubjectList();
            }
            //hàm xử lý sự kiện nút Lọc
            function onBtnFilterClick() {
                var vStudent = $("#select-student").val();
                var vSubject = $("#select-subject").val();
                var vDataFilter = gData.filter(function (paramData, index) {
                    return (vStudent == "all" || vStudent === paramData.studentId)
                        && (vSubject == "all" || vSubject === paramData.subjectId)
                });
                //gọi hàm load data vào table
                loadDataToTable(vDataFilter);
            }
            //hàm xử lý sự kiện nút Thêm mới
            function onBtnAddNewClick() {
                //hiển thị modal trắng lên
                $("#modal-add-data").modal("show");
            }
            //hàm xử lý sự kiện nút Thêm mới(trên modal)
            function onBtnCreateDataClick() {
                //khai báo obj chứa data
                var vRequestDataObj = {
                    studentId: "",
                    subjectId: "",
                    grade: "",
                    examDate: ""
                }
                //b1: get data
                getCreateData(vRequestDataObj);
                //b2: validate data
                var vIsValid = validateData(vRequestDataObj);
                //ghi ra console value trả ra của hàm validateData
                console.log(vIsValid);
                if (vIsValid) {
                    //b3: create data
                    $.ajax({
                        url: gBASE_URL + "/grades",
                        type: "POST",
                        contentType: "application/json;charset=UTF-8",
                        data: JSON.stringify(vRequestDataObj),
                        success: function (paramRes) {
                            console.log(paramRes);
                            //b4: xử lý front-end
                            handleCreateSuccess();
                        },
                        error: function (paramErr) {
                            console.log(paramErr.status);
                        }
                    });
                }
            }
            //hàm xử lý sự kiện Update data từ table
            function onBtnEditDataClick(paramEdit) {
                //lưu thông tin Id đang dc edit vào biến toàn cục
                gId = getIdFromButton(paramEdit);
                console.log("Id của data tương ứng = " + gId);
                // load dữ liệu vào các trường dữ liệu trong modal
                getDataById(gId);
            }
            //hàm xử lý sự kiện nút Cập nhật(trên modal)
            function onBtnUpdateDataClick() {
                //khai báo obj chứa user data
                var vRequestDataObj = {
                    studentId: "",
                    subjectId: "",
                    grade: "",
                    examDate: ""
                }
                //b1: get data
                getUpdateData(vRequestDataObj);
                //b2: validate data
                var vIsValid = validateData(vRequestDataObj);
                if (vIsValid) {
                    //b3: update data
                    $.ajax({
                        url: gBASE_URL + "/grades/" + gId,
                        type: "PUT",
                        contentType: "application/json;charset=UTF-8",
                        data: JSON.stringify(vRequestDataObj),
                        success: function (paramRes) {
                            console.log(paramRes);
                            //b4: xử lý front-end
                            handleUpdateDataSuccess();
                        },
                        error: function (paramErr) {
                            console.log(paramErr.status);
                        }
                    });
                }
            }
            //hàm xử lý sự kiện Delete data từ table
            function onBtnDeleteDataClick(paramDelete) {
                //lưu thông tin Id đang dc xóa vào biến toàn cục
                gId = getIdFromButton(paramDelete);
                console.log("Id của data tương ứng = " + gId);
                $("#modal-delete-data").modal("show");
            }
            // hàm xử lý sự kiện delete data modal click
            function onBtnDeleteDataConfirmClick() {
                // B1: Thu thập dữ liệu(k có)
                // B2: Validate delete(k có)
                // B3: call api to delete data
                $.ajax({
                    url: gBASE_URL + "/grades/" + gId,
                    type: "DELETE",
                    contentType: "application/json;charset=UTF-8",
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleDeleteDataSuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
            }
            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
            //hàm gọi api để lấy data để load lên table
            function getDataToLoadToTable() {
                $.ajax({
                    url: gBASE_URL + "/grades",
                    type: "GET",
                    success: function (paramRes) {
                        //ghi response ra console
                        console.log(paramRes);
                        gData = paramRes;
                        loadDataToTable(gData);
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
            }
            // load data to DataTable
            function loadDataToTable(paramData) {
                gDataTable.clear();
                gDataTable.rows.add(paramData);
                gDataTable.draw();
            }
            //hàm gọi api get student list
            function getStudentList() {
                $.ajax({
                    url: gBASE_URL + "/students",
                    type: "GET",
                    success: function (res) {
                        console.log("%cStudent Object: ", "color:blue", res);
                        handleStudentList(res);
                        gStudentObj = res;
                    },
                    error: function (ajaxContext) {
                        alert(ajaxContext.responseText);
                    }
                });
            }

            //hàm tạo option cho select student
            function handleStudentList(paramStudent) {
                $.each(paramStudent, function (i, item) {
                    $("#select-student").append($("<option>", {
                        text: item.firstname + " " + item.lastname,
                        value: item.id
                    }));
                    $("#select-create-student").append($("<option>", {
                        text: item.firstname + " " + item.lastname,
                        value: item.id
                    }));
                    $("#select-update-student").append($("<option>", {
                        text: item.firstname + " " + item.lastname,
                        value: item.id
                    }));
                });
            }
            //hàm gọi api get subject list
            function getSubjectList() {
                $.ajax({
                    url: gBASE_URL + "/subjects",
                    type: "GET",
                    success: function (res) {
                        console.log("%cSubject Object: ", "color:green", res);
                        handleSubjectList(res);
                        gSubjectObj = res;
                    },
                    error: function (ajaxContext) {
                        alert(ajaxContext.responseText);
                    }
                });
            }

            //hàm tạo option cho select subject
            function handleSubjectList(paramSubject) {
                $.each(paramSubject, function (i, item) {
                    $("#select-subject").append($("<option>", {
                        text: item.subjectName,
                        value: item.id
                    }));
                    $("#select-create-subject").append($("<option>", {
                        text: item.subjectName,
                        value: item.id
                    }));
                    $("#select-update-subject").append($("<option>", {
                        text: item.subjectName,
                        value: item.id
                    }));
                });
            }

            //hàm render stt
            function renderStt() {
                gSTT_COL++;
                return gSTT_COL;
            }
            //hàm render từ subjectId sang subjectName
            function renderSubjectIdToSubjectName(paramSubjectId) {
                var vSubjectName = "";
                var vFound = false;
                var vViTriHienTai = 0;
                while (!vFound && vViTriHienTai < gSubjectObj.length) {
                    if (gSubjectObj[vViTriHienTai].id === paramSubjectId) {
                        vSubjectName = gSubjectObj[vViTriHienTai].subjectName;
                        vFound = true;
                    }
                    vViTriHienTai++;
                }
                return vSubjectName;
            }
            //hàm render từ studentId sang studentName
            function renderStudentIdToStudentName(paramStudentId) {
                var vStudentName = "";
                var vFound = false;
                var vViTriHienTai = 0;
                while (!vFound && vViTriHienTai < gStudentObj.length) {
                    if (gStudentObj[vViTriHienTai].id === paramStudentId) {
                        vStudentName = gStudentObj[vViTriHienTai].firstname + " " + gStudentObj[vViTriHienTai].lastname;
                        vFound = true;
                    }
                    vViTriHienTai++;
                }
                return vStudentName;
            }
            //hàm thu thập create data
            function getCreateData(paramDataObj) {
                paramDataObj.studentId = $("#select-create-student").val();
                paramDataObj.subjectId = $("#select-create-subject").val();
                paramDataObj.grade = $("#inp-create-grade").val().trim();
                paramDataObj.examDate = $("#inp-create-examdate").val().trim();
            }
            //hàm validate data
            function validateData(paramDataObj) {
                if (paramDataObj.studentId === "0") {
                    alert("Chưa chọn sinh viên!");
                    return false;
                }
                if (paramDataObj.subjectId === "0") {
                    alert("Chưa chọn môn học!");
                    return false;
                }
                if (paramDataObj.grade === "") {
                    alert("Chưa nhập điểm!");
                    return false;
                }
                if (isNaN(paramDataObj.grade) || paramDataObj.grade < 0 || paramDataObj.grade > 10) {
                    alert("Điểm phải là số nguyên từ 0-10!");
                    return false;
                }
                if (paramDataObj.examDate === "") {
                    alert("Chưa nhập ngày thi!");
                    return false;
                }
                return true;
            }
            //hàm xử lý front-end khi add data thành công
            function handleCreateSuccess() {
                alert("Thêm mới bảng điểm thành công!");
                window.location.reload();
                getDataToLoadToTable(); //load lại table
                resetCreateDataForm(); //reset trắng lại form modal add data
                $("#modal-add-data").modal("hide");
            }
            //hàm xóa trắng form create data
            function resetCreateDataForm() {
                $("#select-create-student").val("0");
                $("#select-create-subject").val("0");
                $("#inp-create-grade").val("");
                $("#inp-create-examdate").val("");
            }
            //hàm dựa vào button detail (edit or delete) xác định dc id data
            function getIdFromButton(paramButton) {
                var vTableRow = $(paramButton).parents("tr");
                var vRowData = gDataTable.row(vTableRow).data();
                return vRowData.id;
            }
            //hàm load data lên update modal form
            function getDataById(paramId) {
                $.ajax({
                    url: gBASE_URL + "/grades/" + paramId,
                    type: "GET",
                    success: function (parammId) {
                        showDataToUpdateModal(parammId);
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
                // hiển thị modal lên
                $("#modal-update-data").modal("show");
            }
            //hàm show data lên update modal form
            function showDataToUpdateModal(paramDataObj) {
                $("#select-update-student").val(paramDataObj.studentId);
                $("#select-update-subject").val(paramDataObj.subjectId);
                $("#inp-update-grade").val(paramDataObj.grade);
                $("#inp-update-examdate").val(paramDataObj.examDate);
            }
            //hàm thu thập update data
            function getUpdateData(paramDataObj) {
                paramDataObj.studentId = $("#select-update-student").val();
                paramDataObj.subjectId = $("#select-update-subject").val();
                paramDataObj.grade = $("#inp-update-grade").val().trim();
                paramDataObj.examDate = $("#inp-update-examdate").val().trim();
            }
            //hàm xử lý front-end khi update data thành công
            function handleUpdateDataSuccess() {
                alert("Cập nhật bảng điểm thành công!");
                window.location.reload();
                getDataToLoadToTable();
                $("#modal-update-data").modal("hide");
            }
            //hàm xử lý front-end khi delete course thành công
            function handleDeleteDataSuccess() {
                alert("Xóa bảng điểm thành công!");
                window.location.reload();
                getDataToLoadToTable();
                $("#modal-delete-data").modal("hide");
            }
        });
    </script>
</body>

</html>